(* Coq definitions for the ICFP '01 contest. *)

Load NativeDefs.

(* the type of documents.
   XXX we don't write out datatype definitions for
   "size" and "color" -- we just use strings.
     Also, strings will be an abstract type -- coq
   will only know whether they're blank or not. *)
Inductive document : Set :=
  d_list : document_list -> document
| d_blank_chars : string -> document
| d_nonblank_chars : string -> document
| d_B : document -> document
| d_EM : document -> document
| d_I : document -> document
| d_PL : document -> document
| d_S : document -> document
| d_TT : document -> document
| d_U : document -> document
| d_size : string -> document -> document
| d_color : string -> document -> document
with document_list : Set :=
  doc_list : (list document) -> document_list.

(* the type of property records. *)
Record properties : Set := mk_properties {
  b : bool;
  em : bool;
  i : bool;
  s : bool;
  tt : bool;
  u : nat;
  u_no_more_than_three : (le u (S (S (S O))) );
  size : string;
  color : string
}.



